## ros-dashing-file-management 1.1.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(file_management)
set(FILE_MANAGEMENT_VERSION 1.0.0)

# Default to C11
if(NOT CMAKE_C_STANDARD)
    set(CMAKE_C_STANDARD 11)
endif()
# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 14)
endif()

# Enable strict compiler flags if possible.
include(CheckCXXCompilerFlag)
# Removed -Wmissing-declarations until gmock is ignored
set(FLAGS -pedantic -Wno-long-long -Wall -Wextra -Wcast-qual -Wformat -Wwrite-strings -Wcast-align -Wno-error=cast-align)
foreach(FLAG ${FLAGS})
  check_cxx_compiler_flag(${FLAG} R${FLAG})
  if(${R${FLAG}})
    set(WARNING_CXX_FLAGS "${WARNING_CXX_FLAGS} ${FLAG}")
  endif()
endforeach()

if(NOT DEFINED CXX_DISABLE_WERROR)
  set(WARNING_CXX_FLAGS "-Werror ${WARNING_CXX_FLAGS}")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WARNING_CXX_FLAGS}")

find_package(dataflow_lite REQUIRED)
find_package(aws_common REQUIRED)

if(AWSSDK_FOUND)
  set(SERVICE core)
  AWSSDK_DETERMINE_LIBS_TO_LINK(SERVICE OUTPUT)
  link_directories("${AWSSDK_LIB_DIR}")
endif()

set(ALL_SRC_FILES
    src/file_upload/file_manager_strategy.cpp
    ) 

add_library(${PROJECT_NAME} SHARED ${ALL_SRC_FILES})
target_link_libraries(${PROJECT_NAME} ${OUTPUT} ${dataflow_lite_LIBRARIES} stdc++fs)
target_include_directories(${PROJECT_NAME}
        PRIVATE ${AWSSDK_INCLUDE_DIRS} include ${aws_common_INCLUDE_DIRS} ${dataflow_lite_INCLUDE_DIRS})
target_include_directories(${PROJECT_NAME} PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

#############
## Install ##
#############
install(TARGETS ${PROJECT_NAME}
        EXPORT "${PROJECT_NAME}-targets"
        ARCHIVE DESTINATION lib
        LIBRARY DESTINATION lib
        RUNTIME DESTINATION bin)

install(DIRECTORY include/
        DESTINATION include)

export(TARGETS ${PROJECT_NAME}
        FILE "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-targets.cmake")
export(PACKAGE ${PROJECT_NAME})

CONFIGURE_FILE(${PROJECT_NAME}Config.cmake.in
               ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake @ONLY)
CONFIGURE_FILE(${PROJECT_NAME}ConfigVersion.cmake.in
               ${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake @ONLY)

INSTALL(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake DESTINATION share/${PROJECT_NAME}/cmake)
INSTALL(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake DESTINATION share/${PROJECT_NAME}/cmake)
INSTALL(EXPORT ${PROJECT_NAME}-targets DESTINATION share/${PROJECT_NAME}/cmake)


#############
## Testing ##
#############

enable_testing()
find_common_test_packages()
if(GMOCK_LIBRARY)

  macro(link_test_target target_name)
    if(TARGET ${target_name})
      target_include_directories("${target_name}" PRIVATE ${HEADERS_FOR_TESTS})
      target_link_libraries("${target_name}" ${LIBS_FOR_TESTS})
    endif()
  endmacro()

  add_common_gtest(test_common_utilities
          test/file_management/file_manager_strategy_test.cpp
          test/file_management/file_upload_streamer_test.cpp
          test/file_management/token_test.cpp
          )

  set(LIBS_FOR_TESTS
          ${GTEST_LIBRARIES}
          pthread
          ${GMOCK_LIBRARY}
          ${PROJECT_NAME}
          )

  set(HEADERS_FOR_TESTS
          PRIVATE include
          PRIVATE ${aws_common_INCLUDE_DIRS}
          PUBLIC ${PROJECT_SOURCE_DIR}/test/include
          )

  link_test_target(test_common_utilities)

endif()

=== debian/changelog ===
ros-dashing-file-management (1.1.5-1bionic) bionic; urgency=high

  No changes.

 -- AWS RoboMaker <ros-contributions@amazon.com>  Wed, 14 Oct 2020 07:00:00 -0000

ros-dashing-file-management (1.1.4-1bionic) bionic; urgency=high

  * Add AWS logging to batch tests (#58 <https://github.com/aws-robotics/cloudwatch-common/issues/58>)
  * Allow user to automatically delete CloudWatch logs in batch that are > 14 days old (#56 <https://github.com/aws-robotics/cloudwatch-common/issues/56>)
    * move docstring and don't break loop
    * call fileUploadComplete
    * modify struct and add tests
    * add tests and change 2 week wording to old
    * Add lock to discard stale data container
    * extend stale data protection
    * remove setter
    * Reduce lock_guard scope
  * Bumping version to match bloom release (#51 <https://github.com/aws-robotics/cloudwatch-common/issues/51>)
    Bumping version to 1.1.3
  * Fix linting issues found by clang-tidy 6.0 (#50 <https://github.com/aws-robotics/cloudwatch-common/issues/50>)
    * clang-tidy fixes
    * revert explicit constructor declarations to maintain API compatbility
    * clang-tidy linting issues fixed manually
    * fix unit tests build break
  * Increase package version numbers to 1.1.2 (#44 <https://github.com/aws-robotics/cloudwatch-common/issues/44>)
  * Fixes a bug where we did not null check the result of getting the HOM… (#43 <https://github.com/aws-robotics/cloudwatch-common/issues/43>)
    Fixes a bug where we did not null check the result of getting the HOME env variable and also switches to create_directories instead of create_directory so that it doesn't SIGABRT when asked to create multiple levels of a directory.
  * Contributors: Jesse Ikawa, Miaofei Mei, Nick Burek, Ragha Prasad

 -- AWS RoboMaker <ros-contributions@amazon.com>  Thu, 17 Sep 2020 07:00:00 -0000

ros-dashing-file-management (1.1.1-1bionic) bionic; urgency=high

  * Disable error on cast-align warning to support ARMhf builds (#41 <https://github.com/aws-robotics/cloudwatch-common/issues/41>)
    * Remove -Wcast-align flag to support ARMhf builds
    *  - bumped versions to 1.1.1
    - restored cast-align, but added as a warning
    - removed unused headers
    * Removed duplicate Werror
  * modify changelist to be compatible with catkin_generate_changelog (#39 <https://github.com/aws-robotics/cloudwatch-common/issues/39>)
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
  * synchronize version of new packages with rest of the packages in the repo (#38 <https://github.com/aws-robotics/cloudwatch-common/issues/38>)
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
  * Merge pull request #36 <https://github.com/aws-robotics/cloudwatch-common/issues/36> from aws-robotics/guard_test_libs
    Added guards for test libraries
  * Added guards for test libraries
  * Offline logs feature (#34 <https://github.com/aws-robotics/cloudwatch-common/issues/34>)
    * Add file manager and upload complete callback
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Fixed merge conflict
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add file manager test
    Still deciding if the write should just go in the FileManagerStrategy.
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add FileManager to log manager factory
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add generic file upload logic
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add reading, discovery and rotation to FileManagerStrategy
    - Add function getFileToRead that returns the best file to start reading
    from when sending data from the file to CloudWatch.
    - Add function discoverStoredFiles which finds all files in the
    storage directory and keeps them, in case there were offline logs still
    hanging around from a previous run.
    - Add rotateActiveFile which creates a new file to write to. This is
    used when we want to read from the current active file, or when the file
    size limit has been reached.
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add file management system.
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Link file management with publisher
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add test for file management system
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add reading and writing to FileManagerStrategy
    - This way the file manager strategy can handle all the core file data
    stuff, keeping track of the size of the active file and rotating it when
    neccessary.
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * cleanup
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Don't initialize file_manager_strategy yet
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add file upload statistics
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Move file management files to isolated package
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Moved tests to file_manager folder
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Update offline test location
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add comments to file management interfaces
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add more comments to file uploading
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add futures/promises to file upload tasks
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add blocking and observed queue interface
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add comments to observed_queue.h
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Make batch size configurable for file upload manager
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add subscribe method to file upload manager
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Move queues and status monitor to dataflow folder


=== debian/control ===
Source: ros-dashing-file-management
Section: misc
Priority: optional
Maintainer: AWS RoboMaker <ros-contributions@amazon.com>
Build-Depends: debhelper (>= 9.0.0), cmake, ros-dashing-ament-cmake-gmock, ros-dashing-ament-cmake-gtest, ros-dashing-aws-common, ros-dashing-dataflow-lite, ros-dashing-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-dashing-file-management
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-dashing-aws-common, ros-dashing-dataflow-lite, ros-dashing-ros-workspace
Description: AWS CloudWatch management library used to manage offline files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/dashing/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/dashing" \
		-DCMAKE_PREFIX_PATH="/opt/ros/dashing"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-dashing-file-management//opt/ros/dashing/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_install
